unit UBinarios;
{Cuando se necesite redondear, siempre devolver 32 digitos decimales como mximo}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, DecBinHex;

type
  TFPrincipal = class(TForm)
    EdNumero: TEdit;
    LNumero: TLabel;
    GBaseOriginal: TRadioGroup;
    Button1: TButton;
    EdResultado: TEdit;
    Label1: TLabel;
    GBaseResultado: TRadioGroup;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GOper1: TRadioGroup;
    EdOperaciones1: TEdit;
    Label2: TLabel;
    GOper2: TRadioGroup;
    EdOperaciones2: TEdit;
    Label3: TLabel;
    COperacion: TComboBox;
    Label4: TLabel;
    EdOperacionesResultado: TEdit;
    Button2: TButton;
    GOperResultado: TRadioGroup;
    procedure GBaseOriginalClick(Sender: TObject);
    procedure GBaseResultadoClick(Sender: TObject);
    procedure EdNumeroKeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure GOper1Click(Sender: TObject);
    procedure GOper2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FPrincipal: TFPrincipal;

implementation

const
  OTROS = [#0..#31,'.']; //Sin espacios
  DEC = ['0'..'9']+OTROS;
  BIN = ['0','1']+OTROS;
  HEX = ['0'..'9','A'..'F','a'..'f']+OTROS;

{$R *.dfm}

procedure TFPrincipal.Button1Click(Sender: TObject);
var
  Num:String;
  DBH:TDecBinHex;
begin
  Num:=UpperCase(EdNumero.Text);
  DBH.Create();
  case GBaseOriginal.ItemIndex of
    0:
      begin
        case GBaseResultado.ItemIndex of
          1:  EdResultado.Text:=DBH.DecToBin(Num);
          2:  EdResultado.Text:=DBH.DecToHex(Num);
        end;
      end;
    1:
      begin
        case GBaseResultado.ItemIndex of
          0:  EdResultado.Text:=DBH.BinToDec(Num);
          2:  EdResultado.Text:=DBH.BinToHex(Num);
        end;
      end;
    2:
      begin
        case GBaseResultado.ItemIndex of
          0:  EdResultado.Text:=DBH.HexToDec(Num);
          1:  EdResultado.Text:=DBH.HexToBin(Num);
        end;
      end;
  end;
end;

procedure TFPrincipal.Button2Click(Sender: TObject);
var
  DBH:TDecBinHex;
  Num1,Num2:String;
  Tipo1,Tipo2:Char;
begin
  DBH.Create(32);
  Num1:=EdOperaciones1.Text;
  Num2:=EdOperaciones2.Text;
  case GOper1.ItemIndex of
    0: Tipo1:='D';
    1: Tipo1:='B';
    2: Tipo1:='H';
  end;
  case GOper2.ItemIndex of
    0: Tipo2:='D';
    1: Tipo2:='B';
    2: Tipo2:='H';
  end;
  case COperacion.ItemIndex of
    0:
      begin
        case GOperResultado.ItemIndex of
          0: EdOperacionesResultado.Text:=DBH.AddToDec(Num1,Num2,Tipo1,Tipo2);
          1: EdOperacionesResultado.Text:=DBH.AddToBin(Num1,Num2,Tipo1,Tipo2);
          2: EdOperacionesResultado.Text:=DBH.AddToHex(Num1,Num2,Tipo1,Tipo2);
        end;
      end;
    1:
      begin
        case GOperResultado.ItemIndex of
          0: EdOperacionesResultado.Text:=DBH.SubToDec(Num1,Num2,Tipo1,Tipo2);
          1: EdOperacionesResultado.Text:=DBH.SubToBin(Num1,Num2,Tipo1,Tipo2);
          2: EdOperacionesResultado.Text:=DBH.SubToHex(Num1,Num2,Tipo1,Tipo2);
        end;
      end;
    2:
      begin
        case GOperResultado.ItemIndex of
          0: EdOperacionesResultado.Text:=DBH.MultToDec(Num1,Num2,Tipo1,Tipo2);
          1: EdOperacionesResultado.Text:=DBH.MultToBin(Num1,Num2,Tipo1,Tipo2);
          2: EdOperacionesResultado.Text:=DBH.MultToHex(Num1,Num2,Tipo1,Tipo2);
        end;
      end;
    3:
      begin
        case GOperResultado.ItemIndex of
          0: EdOperacionesResultado.Text:=DBH.DivToDec(Num1,Num2,Tipo1,Tipo2);
          1: EdOperacionesResultado.Text:=DBH.DivToBin(Num1,Num2,Tipo1,Tipo2);
          2: EdOperacionesResultado.Text:=DBH.DivToHex(Num1,Num2,Tipo1,Tipo2);
        end;
      end;
  end;
end;

procedure TFPrincipal.EdNumeroKeyPress(Sender: TObject; var Key: Char);
{Restringe los caracteres}
{Funciona bien}
begin
  if (Key = #13) then
    Button1Click(nil)
  else begin
    if (Key = ',') then
      Key:=DecimalSeparator;
    case GBaseOriginal.ItemIndex of
      0:  begin
            if NOT(Key IN DEC) and (Key <> DecimalSeparator) then
              Key:=#0;
          end;
      1:  begin
            if NOT(Key IN BIN) and (Key <> DecimalSeparator) then
              Key:=#0;
          end;
      2:  begin
            if NOT(Key IN HEX) and (Key <> DecimalSeparator) then
              Key:=#0;
          end;
    end;
  end;
end;

procedure TFPrincipal.FormCreate(Sender: TObject);
begin
  DecimalSeparator:='.';
end;

procedure TFPrincipal.GBaseOriginalClick(Sender: TObject);
begin
  case GBaseOriginal.ItemIndex of
    0:  begin
          if (GBaseResultado.ItemIndex=0) then
            GBaseResultado.ItemIndex:=1;
        end;
    1:  begin
          if (GBaseResultado.ItemIndex=1) then
            GBaseResultado.ItemIndex:=0;
        end;
    2:  begin
          if (GBaseResultado.ItemIndex=2) then
            GBaseResultado.ItemIndex:=0;
        end;
  end;
  EdNumero.SetFocus;
  EdNumero.SelStart:=MaxInt;
end;

procedure TFPrincipal.GBaseResultadoClick(Sender: TObject);
begin
  case GBaseResultado.ItemIndex of
    0:  begin
          if (GBaseOriginal.ItemIndex=0) then
            GBaseResultado.ItemIndex:=1;
        end;
    1:  begin
          if (GBaseOriginal.ItemIndex=1) then
            GBaseResultado.ItemIndex:=0;
        end;
    2:  begin
          if (GBaseOriginal.ItemIndex=2) then
            GBaseResultado.ItemIndex:=0;
        end;
  end;
  EdNumero.SetFocus;
  EdNumero.SelStart:=MaxInt;
end;

procedure TFPrincipal.GOper1Click(Sender: TObject);
begin
  EdOperaciones1.SetFocus;
  EdOperaciones1.SelStart:=MaxInt;
end;

procedure TFPrincipal.GOper2Click(Sender: TObject);
begin
  EdOperaciones2.SetFocus;
  EdOperaciones2.SelStart:=MaxInt;
end;

end.
